Issue 8811

Summary: Allow multiple users to edit the same spreadsheet through workbook sharing
Product: Calc Reporter: skiani <skiani>
Component: editingAssignee: oc
Status: CLOSED FIXED QA Contact: issues@sc <issues>
Severity: Trivial    
Priority: P3 CC: afrayer, baumux, chris_mux, chrlutz, cno, dave, falko.tesch, issues, jimca4, kami911, kendy, mpyt, mux2005, pagalmes.lists, stp, thomas.benisch, utomo.prawiro
Version: OOo 1.0.1Keywords: oooqa, rfe_eval_ok
Target Milestone: ---   
Hardware: All   
OS: All   
Issue Type: FEATURE Latest Confirmation in: ---
Developer Difficulty: ---
Issue Depends on:    
Issue Blocks: 80139    
Attachments:
Description Flags
TestCaseSpecification (Beta)
none
List of current open and known issues none

Description skiani 2002-10-29 16:14:21 UTC
Another powerful feature for collaborating is workbook sharing (in fact we use
this for managing a project for Sun). Basically allows multiple users to edit
the same spreadsheet, tracks changes, locks cells that are being changed, tracks
changes, and keeps each user's view up to date. It also limits what you can do
with the workbook while it is being shared.
Comment 1 skiani 2002-10-30 12:50:52 UTC
One additional issue I just noticed (which I would type as a DEFECT).
When an excel workbook is shared the file is not locked (assuming you
have file locking on your Samba server turned or your using a windows
server), so if you open it with OOo edit and save all other shared
users who have the file lose their work. It says tells them that their
session was broken for some reason and their only option is to do a
save as.

If you choose not to suppore shared workbooks feature then at a
minimum you should detect it when you open the file and force a read
only status.
Comment 2 peter.junge 2002-11-28 17:49:42 UTC
Hi Falko,
1 4 U.
Peter
Comment 3 peter.junge 2002-11-28 17:50:53 UTC
For FT and not for me.
Comment 4 falko.tesch 2003-10-15 10:18:07 UTC
This is an collaboration issue that shoulsd be covered by 2.0's successor.
Comment 5 falko.tesch 2003-10-15 10:18:24 UTC
Started
Comment 6 erwin.tenhumberg 2004-09-30 14:18:43 UTC
enhanced summary, set keywords and reassigned issue according to RFE process

Comment 7 frank 2005-01-13 13:34:40 UTC
*** Issue 39521 has been marked as a duplicate of this issue. ***
Comment 8 frank 2005-09-30 16:15:47 UTC
*** Issue 13597 has been marked as a duplicate of this issue. ***
Comment 9 mathiasm 2005-12-03 23:02:52 UTC
I'm working in a bank.
OOo is being studied for now. Shared spreadsheets is very used in these 
environnments. A must-have, IMO.
Comment of Skiani confirmed in OOo2.0.

Comment 10 onebadwebmonkey 2006-02-13 23:43:38 UTC
We need to be able to open a Calc file by multiple people and make realtime
changes.  Please add sharing capability.  Thx.
Comment 11 mgrillini 2006-06-18 11:11:33 UTC
This feature is very important for small/medium factories. I have been requested
for it from a very important customer who want to migrate to OOo. A database
application can't solve the problem: they only need to have a nice and
easy-to-use graphical Interface. Please, do something similar to Excel sharing
capability!!!!!
Comment 12 utomo99 2006-11-19 05:28:30 UTC
FT, Can you please take care about this issue, since you already say Started ?
But Since 2003 until now we did not hear any more news.  please update the 
target if necessary.
Thanks


------- Additional comments from ft Wed Oct 15 01:18:24 -0800 2003 -------

Started
 
Comment 13 kendy 2006-11-29 13:13:09 UTC
I started working on this...

ft: Is there any work on this already done?  I'd prefer not to reinvent the 
wheel ;-)
Comment 14 kpalagin 2007-01-19 19:46:09 UTC
*** Issue 73670 has been marked as a duplicate of this issue. ***
Comment 15 rmcc4444 2007-01-20 01:50:00 UTC
this is one of the final features that is keeping us from migrating to a
complete ooo environment.
Comment 16 deonast 2007-02-06 12:36:33 UTC
I recently setup a number of computers in Tonga for a government department
there.  I used mostly open source software.  I would have used open office, but
unfortunately they needed this feature with multiple users updating the same
spreadsheet at the same time.  This meant we had to buy Office 2003.  This
functionality would have enabled me to push open office as an alternative.
Comment 17 rogerstgermain 2007-03-10 01:47:08 UTC
We have 20 users but without this feature we cannot use Open Office.
Comment 18 cno 2007-04-27 09:32:37 UTC
*** Issue 76570 has been marked as a duplicate of this issue. ***
Comment 19 bobharvey 2007-07-26 12:01:42 UTC
I have noticed that people only ask for this for spreadsheets.

Are we talking just about the cells of spreadsheets, or about the layout and
titling of graphs as well? Why not documents, drawings, or slide shows? 

If a "collaboration" method is to be provided surely it should be for every type
of document, not just one?

I must declare an interest here: I think organisations that do this instead of
using a database system are stark staring raving bonkers.
Comment 20 mathiasm 2007-07-26 12:44:40 UTC
Answer to  bobharvey :
Yes, this can be done for every kind of documents.
The main reason we asked it for calc is because of migration from MSOffice. The 
feature, available in Excel, is very used in small teams, and thus the lack of 
this feature is a drawback for the migration.
practical for some kind of temporary documents.
Well, about your interest, i'll give you an example: For one project, which 
lasts about 1 month, I propose a calc sheet to fill in all tasks, in order to 
report information later to the HQ. Shall I ask my client to give me a database 
or use a spreadsheet which allows for concurrent access ? Not saying that cost 
is all for my client, huh? Remember I have only one month, and no time to argue
 :-)
So whatever you think (and i agree with you about some uses), this feature is 
*needed*. I think votes express that, actually.
Comment 21 rmcc4444 2007-07-28 20:23:23 UTC
this is still the one major that is keeping us from migrating to openoffce.org.
 its about 5000 seats.
Comment 22 thomas.benisch 2007-08-24 10:52:33 UTC
TBE->KENDY: Are you still working on this?
Comment 23 kendy 2007-08-27 17:05:14 UTC
tbe: The work is stalled ATM due to higher priority tasks; if you can work on 
this, please do :-)  I can provide you with ideas & patches (mostly of 
proof-of-concept nature) I've done so far.
Comment 24 kbuoy 2007-08-27 18:03:25 UTC
My department uses shared Excel spreadsheets extensively and OO is currently
being tested by several as a replacement to MS Office.  But lack of 'share' in
spreadsheet will prevent complete migration to OO.  This is definitely a
powerful tool that OO Calc should include.
Comment 25 thomas.benisch 2007-08-29 13:35:35 UTC
kendy: I plan to work on a prototype. Of course your contributions
are appreciated and welcome. If you want to contribute some patches,
I propose to attach them to this issue. For discussing your ideas
the best place is probably the dev@sc.openoffice.org mailing list.
Comment 26 kendy 2007-09-11 14:07:51 UTC
tbe: So, what I did so far is in ooo-build:

http://svn.gnome.org/viewcvs/ooo-build/trunk/patches/src680/shared-worksheets.diff

It is the proof-of-concept code, treats every workbook as the shared one.  It 
lacks the switch in the data format to indicate that the workbook is, or is not 
shared.  It also does not implement any locking needed for the proper 
functionality in the shared environment; it has just TODO's in the code.

For the functionality, it needs also this patch:

http://svn.gnome.org/viewcvs/ooo-build/trunk/patches/src680/modal-changes-dialog.diff

This implements modal version of the changes dialog which is used for the 
resolution what changes should be accepted - of course, it is the first shot, 
later some more automatic should be added I guess.

All the code is about 3/4 year old, sorry if it does not apply as-is.
Comment 27 kendy 2007-10-17 17:22:16 UTC
tbe: As you are working on the implementation, I guess you are the right owner 
now ;-)  Please, do you have a CWS for this yet?  I might have some time to 
help, so...
Comment 28 thomas.benisch 2007-10-18 13:20:21 UTC
This issue needs to be evaluated first, therefore set to requirements.
Comment 29 thomas.benisch 2007-12-03 12:54:04 UTC
We will give it a try.

Please see my blog posting at:

http://blogs.sun.com/GullFOSS/entry/collaboration_for_calc_with_shared
Comment 30 thomas.benisch 2007-12-07 15:31:15 UTC
As discussed with FST set target to OOo 3.0, priority P3 and issue type FEATURE.
Comment 31 thomas.benisch 2007-12-07 15:32:13 UTC
accepted
Comment 32 thomas.benisch 2008-02-28 17:32:47 UTC
Please see the specification at

http://specs.openoffice.org/calc/features/Collaboration.odt
Comment 33 thomas.benisch 2008-02-28 18:07:17 UTC
fixed on CWS calcshare

Note, that file locking is not working reliable when working on different file
systems
(nfs, samba, etc.). This will be fixed in a follow-up issue.
Comment 34 thomas.benisch 2008-02-28 18:52:14 UTC
TBE->OC: Please verify in CWS calcshare.
Comment 35 oc 2008-03-05 15:28:22 UTC
Created attachment 51910 [details]
TestCaseSpecification (Beta)
Comment 36 oc 2008-03-05 15:30:30 UTC
Created attachment 51911 [details]
List of current open and known issues
Comment 37 oc 2008-03-05 19:25:14 UTC
verified in internal build cws_calcshare
Comment 38 oc 2008-08-05 15:24:37 UTC
closed because fix available in builds DEV300_m28
Comment 39 Edwin Sharp 2013-11-26 19:09:30 UTC
*** Issue 108527 has been marked as a duplicate of this issue. ***